;**************************************

ASTB1   ; 

;#00-RCD  (57*2)
;#72-. (23*2)
;#A0- .  (36)
;#C4- (12)
;#D0-.     (23*2)

_DW #7100,#7200,#7300,#0000,#8100,#8109
_DW #0200,#2300,#2403,#25C2,#26C4,#2700
_DW #88C1,#88C5,#0980,#0988,#8A90,#0998
_DW #8AA0,#8AB0,#8AA8,#8AB8,#2B40,#2C41
_DW #0D40,#0D80,#0DC0,#8E00,#8E08,#8E10
_DW #8E18,#8E20,#8E28,#8E30,#8E38,#2F01
_DW #3000,#7400,#3500,#7600,#0000,#0000
_DW #0000,#0000,#0000,#0000,#0200,#0200
_DW #2C41,#2300,#2300,#2300,#2300,#25C2
_DW #25C2,#25C2,#25C2

_DW AG00,AG01,AG02,A89,A83,A96
_DW A102,A86,AG08,AG09,AG10,A104
_DW A108,AG13,AG14,A80,A76,ASK1
_DW ASK8,ASEXT,ASK11,A110,ASK40

_DB #F3,#FB,#08,#00,#3F,#37,#2F,#27
_DB #D9,#17,#1F,#07,#0F,#76
_DB #A0,#A8,#B0,#B8,#A1,#A9,#B1,#B9
_DB #A2,#AA,#B2,#BA,#A3,#AB,#B3,#BB
_DB #44,#6F,#67,#70,#4D,#45

_DW FL5,FL6,FL7,FL8,FL9,FL9A

_DW ASADD,ASSUB,ASMUL,ASDIV,ASMOD
_DW ASAND,ASOR,ASXOR,ASSHL,ASSHR
_DW ASMOE,ASBOE,ASMEN,ASBOL
_DW ASEQUAL,ASHIGH,ASLOW,ASUP
_DW ASDOWN,ASFON,ASNEG,ASNOT
_DW ASML256,0

ASTB2   ; 

;#00-.  (33*3)
;#63-.(23  )
;#7A-. (5*2)
;#88-JP  
;#A8-TBSIGN
;#E8-

        DB 1,0,0,1,0,1,1,0,2,1,0,3
        DB 1,1,4,1,1,5,1,2,6,1,3,7
        DB 2,#DD,4,2,#DD,5
        DB 2,#FD,4,2,#FD,5
        DB 3,0,0,3,0,#10
        DB 3,1,#20,3,2,#30
        DB 4,#DD,0,4,#FD,1
        DB 5,0,2,5,1,#12
        DB 5,0,#47,5,1,#4F
        DB 6,8,#30
        DB 7,0,0
        DB 8,0,0
        DB 9,0,0,9,0,8,9,0,#10,9,0,#18
        DB 9,1,#20,9,1,#28
        DB 9,1,#30,9,1,#38

PRPLUS  EQU 4

        DB 4,4,7,7,7,3,3,3
        DB 5,5,2,2,2,2,2
        DB 8,8,8,8,1,6,2,8

        DW ASC24,ASC25,ASC26,ASC27,ASC28
        DW ASC28C,ASC28D

; , L=0
TBJPOP  EX DE,HL : JP 0
        EX DE,HL : JP DL63
        EX DE,HL : JP DL50
        EX DE,HL : JP DLBL0
        EX DE,HL : JP DL72
        EX DE,HL : JP DL67
        EX DE,HL : JP DL58
        EX DE,HL : JP DL68

; 
TBSIGN  DB "+ - * / \ & ! | "
        DB "<<>><=>=< > = "
        DB "[ ] ^ ` ? ~ @ ' "
TBSGN1  DB "; : ,   ",0,#20
        DB "# ",#22,#20,"% ( "
ETBSIGN

AG00    DB AG001-$
        DB AG002-$
        DB AG003-$
        DB AG004-$
        DB AG005-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AG00B-$
        DB AG00C-$
AG000

AG001   DB 6
        DB 1,2,5,10,11,12
        DW A21:DB 1
        DW A24:DB 2
        DW A25:DB #92
        DW A27:DB 2
        DW A30:DB 3
        DW A32:DB 3

AG002   DB 3
        DB 1,2,10
        DW A33:DB 2
        DW A35:DB 2
        DW A27A:DB 3

AG003   DB 4
        DB 3,4,10,11
        DW A36:DB #AA
        DW A40:DB #B2
        DW A42:DB 3
        DW A43:DB #8C

AG004   DB 3
        DB 3,10,11
        DW A45:DB 4
        DW A46:DB 4
        DW A47:DB 4

AG005   DB 1,1:DW A48:DB #9A

AG00B   DB 3
        DB 1,3,4
        DW A50:DB 3
        DW A51:DB #84
        DW A56:DB 4

AG00C   DB 2
        DB 1,10
        DW A57:DB 3
        DW A57A:DB 4

AG01    DB AG011-$
        DB AG012-$
        DB AG013-$
        DB AG014-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AG01C-$

AG011   DB 1,#80:DW A7:DB 1
AG012   DB 1,#80:DW A6:DB 2
AG013   DB 1,#80:DW A9:DB 1
AG014   DB 1,#80:DW A8:DB 2
AG01C   DB 1,#80:DW A10:DB 3

AG02    DB AGN1-$
        DB AGN1-$
        DB AG023-$
        DB AGN1-$
        DB AGN1-$
        DB AG026-$
        DB AG027-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$
        DB AGN1-$

AGN1    DB 1,#FF

AG023   DB 1,3:DW A58:DB 1

AG026   DB 1,6:DW A54:DB 1

AG027   DB 2
        DB 3,4
        DW A59:DB 1
        DW A61:DB 2

AG08    DB AGN2-$
        DB AGN2-$
        DB AG083-$
        DB AG084-$
        DB AGN2-$
        DB AG086-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$

AG083   DB 1,#80:DW A1:DB 1
AG084   DB 1,#80:DW A5:DB 2
AG086   DB 1,#80:DW A2:DB 1

AG09    DB AG091-$
        DB AGN2-$
        DB AG093-$
        DB AG094-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$

AG091   DB 4
        DB 1,2,10,12
        DW A62:DB 1
        DW A62A:DB 2
        DW A64:DB 2
        DW A65:DB 3

AG093   DB 1,3:DW A66:DB #A1

AG094   DB 2
        DB 3,4
        DW A69:DB 2
        DW A70:DB 2

AG10    DB AG101-$
        DB AG102-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AG10A-$
        DB AGN2-$
        DB AG10C-$

AG101   DB 1,#80:DW A2:DB 1
AG102   DB 1,#80:DW A14:DB 2
AG10A   DB 1,#80:DW A15:DB 2
AG10C   DB 1,#80:DW A17:DB 3

AG13    DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AG13A-$
        DB AGN2-$
        DB AGN2-$

AG13A   DB 2
        DB 1,12
        DW A72:DB 2
        DW A75:DW 4

AG14    DB AG141-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AGN2-$
        DB AG14C-$

AG141   DB 1,#80:DW A11:DB 2
AG14C   DB 1,#80:DW A13:DB 4

AGN2    DB 1,#FF

;**************************************

ASL0    LD DE,(ASNLN)
        INC DE
        LD (ASNLN),DE
INCLMD  NOP
ASLINE  XOR A:LD (ASSTAT),A
        LD A,(HL):INC HL
        INC A :JP Z,WRCODE
ASL     DEC A :JP M,ASL4
        LD C,A
        AND #3F
        CP 9:JR NC,ASL7
        CP 6:JR C,ASL1
        LD A,C
        CP 7
        JR NZ,ASL6
        LD A,(HL):INC HL
        LD (ASARPT),HL
ASL1A   LD (ASREPT),A
        LD A,#20:LD (ASSTAT),A
        JR ASL6

ASL1    OR A:JR Z,ASL7A
        LD A,(HL)
        CP 1 : JR Z,ASL9A
        CP #41:JR Z,ASL9A
        INC HL:INC A:JR ASL

ASL2    XOR A; 
ASL3    CP (HL):INC HL:JR NZ,ASL3
        JR ASL9A

ASL4    CP #C0:JR C,ASL8; .
        CP #DC:JR NC,ASL8
        BIT 6,(HL)
        JR Z,ASL8
        LD A,(PASS):OR A
        JR NZ,ASL5
        DEC HL
        CALL FLABEL
        LD A,(ASSTAT)
        OR #80
        LD (ASSTAT),A
        JR ASL6

ASL5    BIT 7,(HL):INC HL:JR Z,ASL5
ASL6    LD A,(HL):INC HL
        CP #09:JP C,ASL7A
        CP #40:JR C,ASL8
        CP #49:JR NC,ASL8
ASL7A   DEC HL:JR ASL9A

ASL7    LD A,C
        CP #2F:JR Z,ASL2
ASL8    CALL ASC
ASL9
ASL9A   LD A,LX:CP #C0
        CALL NC,WRCODE
        LD A,(ASSTAT)
        RES 6,(HL)
        RLA:RLA:JR NC,ASL10
        SET 6,(HL)
ASL10   INC HL
        RLA:JP NC,ASL0
        LD A,(ASREPT):DEC A
        JP Z,ASL0
        LD HL,(ASARPT)
        JP ASL1A

;. 
;A-FIRST (HL)-NEXT
;NC-END (HL)=LEN
;C A= 0-INCB 1-INCL 2-CL_BUF 3-SAVE
;.:(SP)-.. JP (IY)

ASC0    LD A,(ASSTAT):INC A
        LD (ASSTAT),A
        LD A,(HL):INC HL
ASC     CP #2F:JR NC,ASC8
        CP #0B:JP C,ASC15A
ASC1    EX DE,HL
        LD L,A
        LD A,(PASS):OR A
        LD A,L:JR Z,ASC3
        CP #19:JR C,ASC2
        LD (IX),#ED:INC LX
ASC2    ADD A,#95:LD L,A
        LD H,ASTB1/256
        LD A,(HL)
        LD (IX),A
        JR ASC4

ASC3    CP #19:JR C,ASC4
        INC LX
ASC4    INC LX
ASC4A   EX DE,HL
ASC5    LD A,(HL):INC HL
        CP #30:JR C,ASC7A
        CP #40:JR C,ASC6
        CP #6F:JR C,ASC7B
        OR A:JP P,ASC6
        EX DE,HL:CALL ASPA:EX DE,HL
ASC6    LD A,4
ASC6A   CALL ASERR
        JR ASC5

ASC7C   EX DE,HL:INC HL
ASC7A   CP #2F:JP Z,ASPSTR
ASC7B   AND #3F
        CP #2A:JR NC,ASC0
        DEC HL:OR A:RET

ASC8    JP Z,ASPSTR
        OR A:JP P,ASC12
        CP #C0
        JR C,ASC10
        CP #DC
        LD A,#4E
        JR NZ,ASC13
        LD A,#6C
        JR ASC13

ASC10   BIT 5,A:JR Z,ASC12A
ASC11   LD A,#4A
        JR ASC13

ASC12A  LD A,#4E:JR ASC13

ASC15A  SUB #09:CP 2
        JR C,ASC15
        JP GERR

ASC12   CP #40:JR C,ASC11
        CP #6F:JR C,ASC14
ASC13   DEC HL
ASC14   SUB #47
ASC15   EX DE,HL; DE-TEXT
        ADD A,A:LD L,A
        LD H,ASTB1/256
        LD C,(HL):INC L; B-GROUP+STAT
        LD B,(HL); C-ADD
        LD A,B:LD R,A
        AND #1F:ADD A,A
        ADD A,#72:LD L,A
        LD A,(HL):INC L
        LD H,(HL):LD L,A
        LD LY,C
        BIT 5,B
        JP NZ,ASC29;EQU etc
        LD (ASC17+1),HL
ASC16   CALL AZ:DEC A:JP M,ASC18
        LD HY,A
        PUSH HL
        LD A,R:AND #80:JR NZ,ASC17A
        CALL AZ
        PUSH HL
        EXX:POP BC:POP DE:EXX
        OR A:JR NZ,ASC17
ASC18   LD A,6:JR ASC20
ASC19   LD A,7
ASC20   EX DE,HL:JP ASC6A

ASC17A  EXX:POP DE:EXX
ASC17   LD HL,0
        LD B,0:LD C,HY
        ADD HL,BC
        LD C,(HL)
        ADD HL,BC
        LD C,(HL):INC HL
        LD HY,C
        CPIR:JR NZ,ASC19
        DEC HY
        LD A,HY:ADD A,A:ADD A,HY
        SUB C:SUB C:LD C,A
        ADD HL,BC
        LD A,(PASS):OR A
        JR Z,ASC21
        CALL ASC28A
        PUSH HL:POP IX
        EXX
ASC17B  LD A,(DE)
        CP #30:JP C,ASC7C
        CP #40:JR C,ASC16
        CP #6F:JR NC,ASC16
        JP ASC7C

;PASS 0: LD,IDEC,EX,PPUSH,AAS,SBCP,BRS

ASC21   INC HL:INC HL
        LD A,(HL):OR A
        JP P,ASC22
        CALL ASC23
        EXX
        JR NZ,ASC22
        DEC A
ASC22   ADD A,LX:LD LX,A
        JR ASC17B

ASC23   LD C,A
        RRA:RRA:AND #0E
        ADD A,#7A:LD L,A
        LD H,ASTB2/256
        LD A,(HL):INC L
        LD H,(HL):LD L,A
        LD A,C:AND #07
        PUSH HL
        EXX
        RET

ASC24   DEC B : RET
ASC25   DEC D : RET
ASC26   BIT 6,C:RET
ASC27   BIT 6,E:RET

ASC28   LD A,LY:CP #80
        LD A,2 :RET NZ
        LD A,E:CP #10:JR NZ,ASC28B
        LD A,C:CP #20:JR NZ,ASC28B
        LD A,4:RET

ASC28B  LD A,1:RET

ASC28C  LD A,E:ADD A,C
        CP #50:LD A,2:RET

ASC28D  BIT 1,D:RET NZ
        ADD A,2:RET

;PASS1: LD,IDEC,EX,PPUSH,AAS,SBCP,BRS

ASC28A  LD A,(HL):INC HL
        LD H,(HL):LD L,A
        PUSH HL
        EXX
        PUSH IX:POP HL
        RET

;PASS 0/1:
;ORG,EQU,*EXT,JR,DJNZ,JP,CALL
;RET,IN,OUT,IM,RST,DB,DW,DS

ASC29   BIT 6,B
        JR NZ,ASC35
        LD A,(PASS):OR A
        JR Z,ASC30
        INC HL:INC HL
ASC30   LD (ASC32+1),HL
ASC31   CALL AZ
ASC32   CALL 0
ASC33   LD A,(DE)
        CP #30:JR C,ASC34
        CP #40:JR C,ASC31
        CP #6F:JR NC,ASC31
ASC34   JP ASC7C

;PASS 0/1: ORG,EQU,*EXT,DB,DS

ASC35   LD A,(PASS):OR A:JP (HL)

ASK1    CALL WRCODE;ORG
        CALL AZA
        OR A :JR Z,ASK6
        CP 10:JR NZ,ASK5
        PUSH HL
        CALL AZA
        POP BC
        LD (ASADR),BC
        OR A :JR Z,ASK3
        CP 10:JR NZ,ASK5
        LD B,H:LD C,L
ASK3    LD (ASDEST),BC
        LD HL,(ASTART):LD A,H:OR L
        JR NZ,ASK4
        LD (ASTART),BC
ASK4    CALL ASPEL
        JP C,ASC4A
        LD A,4:CALL ASERR
        JR ASK4

ASK5    LD A,7:JR ASK7

ASK6    LD A,6
ASK7    CALL ASERR:JR ASK4

ASK8    JR NZ,ASK10;EQU
        LD A,(ASSTAT):RLA
        JR NC,ASK9
        CALL AZA
        CP 10
        JR NZ,ASK5
        LD A,ASBLBL
        LD BC,#7FFD
        OUT (C),A
        PUSH BC
        LD BC,(AEQULBL)
        LD A,L:LD (BC),A:INC BC
        LD A,H:LD (BC),A
        POP BC
        LD A,ASBTXT
        OUT (C),A
        JR ASK4

ASK9    CALL ASPEL:LD A,12:JR ASK7

ASK10   CALL ASPEL:JR ASK4

ASK11   JR NZ,ASK19;     DB
ASK12   LD A,(DE)
        CP #DC:JR Z,ASK15
        CP #8C:JR Z,ASK14
        CALL ASPEL
        JR C,ASK4
ASK13   INC LX:JR ASK12

ASK14   INC DE:INC DE:INC DE
        INC LX
        JR ASK13

ASK15   INC DE
        LD A,(DE):INC DE
        CP "@":JR Z,ASK18
ASK16   OR A:JR Z,ASK12
        CP #20:JR NC,ASK17
        DEC A:ADD A,LX:LD LX,A
ASK17   INC LX
        LD A,(DE):INC DE
        JR ASK16

ASK18   LD A,(DE):INC DE
        OR A:JR Z,ASK12
        LD A,(DE):INC DE
        OR A:JR Z,ASK12
        INC LX
        JR ASK18

ASK19   CALL ASK19A:JP ASK4

ASK19A  LD A,(DE)
        CP #DC:JR Z,ASK22
        CP #8C:JR Z,ASK21
        CALL AZ:OR A:RET Z
        CP 10:CALL NZ,AE7
        INC H:JR Z,ASK20
        DEC H:CALL NZ,AE8
ASK20   LD (IX),L:INC LX
        JR ASK19A

ASK21   INC DE
        LD A,(DE):INC DE
        LD L,A
        LD A,(DE):INC DE
        OR A:JR Z,ASK20
        LD (IX),A:INC LX
        JR ASK20

ASK22   INC DE
        LD A,(DE):INC DE
        CP "@":JR Z,ASK27
ASK23   OR A:JR Z,ASK19A
        CP #20:JR C,ASK25
        LD (IX),A:INC LX
ASK24   LD A,(DE):INC DE
        JR ASK23

ASK25   LD B,A:LD C,#20
ASK26   LD (IX),C:INC LX:DJNZ ASK26
        JR ASK24

ASK27   LD A,(DE):INC DE
        OR A:JR Z,ASK19A
        CALL ASK29
        RLCA:RLCA:RLCA:RLCA
        LD H,A
        LD A,(DE):INC DE
        OR A:JR Z,ASK28
        CALL ASK29
        OR H
        LD (IX),A:INC LX
        JR ASK27

ASK28   LD A,10:CALL ASERR
        JR ASK19A

ASK29   SUB #30:JR C,ASK30
        CP #0A :RET C
        SUB #07
        CP #0A :JR C,ASK30
        CP #10 :RET C
ASK30   LD A,10:JP ASERR

ASK40   JR NZ,ASK45; DS
        CALL AZA
        CP 10:JR NZ,ASK43
ASK41   LD A,#FF:SUB LX
        LD C,A:LD B,0
        SBC HL,BC
        JR NC,ASK42
        ADD HL,BC
        LD C,L:LD L,0
ASK42   LD A,LX:ADD A,C:LD LX,A
        CP #C0:JR C,ASK44
        CALL WRCODE
        JR ASK41

ASK43   CALL AE7
ASK44   CALL ASPEL:JR NC,ASK44
ASK44A  JP ASC4A

ASK45   CALL AZ
        CP 10:JR NZ,ASK43
        CALL WRCODE
ASK46   PUSH HL
        CALL ASK19A
        PUSH DE
        LD A,LX:OR A
        JR NZ,ASK47
        LD (IX),0:INC LX
        INC A
ASK47   LD E,LX:LD D,#FF
        LD B,8 :XOR A
ASK48   RL D:RLA:SUB E
        JR NC,ASK49
        ADD A,E
ASK49   DJNZ ASK48
        CPL:SUB LX
        JR Z,ASK50
        LD C,A
        LD D,HX:LD E,LX
        LD H,D :LD L,B
        LDIR
ASK50   ADD A,LX
        LD C,A
        POP DE
        POP HL
ASK51   LD A,H:OR L:JP Z,ASC4A
        SBC HL,BC
        JR NC,ASK52
        ADD HL,BC
        LD C,L:LD L,0
ASK52   LD LX,C
        CALL WRCODE
        JR ASK51

ASEXT   LD A,(DE):INC DE
        OR A:JR Z,ASEXT1
        DEC A:JR NZ,ASK44
        CALL WRCODE;INCB
        CALL MINCB
        JR ASK44

ASEXT1  CALL MINCL;     INCL
        JR ASK44

; 

A1      BIT 1,D:JR NZ,AE7
;PUPOP3
A2      LD A,E;    PUPOP 6,SBCP1
A3      ADD A,LY
A4      LD (HL),A:INC L:RET

A5      LD (HL),D:INC L; PUPOP4
        LD A,LY:ADD A,#20
        LD (HL),A:INC L:RET

A6      LD (HL),D:INC L;  IDEC 2
A7      LD A,LY:AND #01;  IDEC 1
        LD D,A
        LD A,E:SCF:ADC A,A
        ADD A,A:ADD A,A
        ADD A,D:JR A4

A8      LD (HL),D:INC L;  IDEC 4
        LD E,#20
A9      LD A,LY:AND #08;  IDEC 3
        ADD A,3:ADD A,E
        JR A4

A10     LD B,E;          IDEC 12
        LD E,#06:CALL A6
        LD (HL),B:INC L
        RET

A11     LD (HL),#CB:INC L;RLSR 1
        LD A,E
A12     ADD A,LY:JR A4

A13     LD (HL),D:INC L; RLSR 12
        LD (HL),#CB:INC L
        LD (HL),E : INC L
        LD A,6:JR A12

A14     LD (HL),D:INC L; SBCP 2
        JR A2

A15     INC D:JR Z,A15B
;SBCP 10
        DEC D:JP NZ,AE8
A15B    LD A,LY:ADD A,#46
A15A    LD (HL),A:INC L
A16     LD (HL),E:INC L
        RET

A17     LD (HL),D:INC L; SBCP 12
        LD A,6:CALL A3
        JR A16

AE7     LD A,7:JP ASERR

A21     LD A,D:CP B:JR NZ,A22
;LD 1,1
        CP 2:JR Z,AE7
A22     LD A,E
        ADD A,A:ADD A,A:ADD A,A
        ADD A,C:ADD A,#40
A23     LD (HL),A:INC L
        RET

;LD 1,2
A24     LD A,D:DEC A
        CP 2:JR C,AE7
        LD (HL),B:INC L
        JR A22

A25     LD A,D:CP 3:JR NZ,AE7
;LD 1,5
        BIT 6,C:JR NZ,A26
        LD A,C:ADD A,8:JR A23

A26     LD A,C:ADD A,#10
        LD (HL),#ED:INC L
        LD (HL),A : INC L
        RET

A27A    LD (HL),D:INC L; LD 2,10
A27     LD A,E;          LD 1,10
        ADD A,A:ADD A,A:ADD A,A
        ADD A,6
        LD (HL),A:INC L
A28     LD A,B:OR A
        JR Z,A29
        INC A:JP NZ,AE8
A29     LD A,C:JR A23

A30     LD A,D:CP 3;     LD 1,11
        JR NZ,AE7
        LD A,#3A
A31A    LD (HL),A:INC L
A31     LD (HL),C:INC L
A31B    LD (HL),B:INC L
        RET

A32     LD A,D:CP 2:JR Z,AE7_1
;LD 1,12
        LD (HL),B:INC L
        LD B,C:LD C,6
        CALL A22
        JR A31B

A33     LD A,B:DEC A;     LD 2,1
        CP 2:JR C,AE7_1
A34     LD (HL),D:INC L
        JR A22

A35     LD A,B:CP D;     LD 2,2
        JR Z,A34
AE7_1   JP AE7

A36     BIT 1,D:JR Z,A38
;LD 3,3
        DEC B :JR NZ,AE7_1
A37     LD (HL),#F9:INC L:RET

A38     BIT 1,B:JR NZ,AE7_1
        CALL A41
A39     INC E:INC C:JP A22

A40     LD A,D:OR A;     LD 3,4
        JR NZ,A40A
        LD (HL),B:INC L
        LD C,#20:CALL A41
        LD (HL),B:INC L
        JR A39

A40A    DEC A:JR Z,AE7_1
        LD (HL),B:INC L
        JR A37




A41     LD A,E:RRA:RRA:RRA
        LD E,A
        LD A,C:RRA:RRA:RRA
        LD C,A
        JP A22

A42     LD A,E:INC A;    LD 3,10
        JR A31A

A43     DEC D:LD A,#2A;  LD 3,11
        JR Z,A31A
        LD (HL),#ED:INC L
        LD A,E:ADD A,#4B
A44     JR A31A

A45     LD A,B:OR A;     LD 4,3
        JR NZ,AE7_1
        LD (HL),D:INC L
        LD E,#20 :CALL A41
        LD (HL),D:INC L
        JR A39

A46     LD (HL),D:INC L; LD 4,10
        LD A,#21 :JR A44

A47     LD (HL),D:INC L; LD 4,11
        LD A,#2A :JR A44

A48     LD A,B:CP 3;     LD 5,1
        JR NZ,AE7_1
        BIT 6,E:JR Z,A49
        LD (HL),#ED:INC L
A49     JP A16

A50     LD A,B:CP 3;     LD 11,1
        JR NZ,AE7_1
        LD A,#32:JR A52

A51     DEC B;          LD 11,3
        JR NZ,A55
A51A    LD A,#22
A52     LD (HL),A:INC L
A53     LD (HL),E:INC L
A54     LD (HL),D:INC L; EX 6,6
        RET

A55     LD (HL),#ED:INC L
        LD A,C:ADD A,#43
        JR A52

A56     LD (HL),B:INC L; LD 11,4
        JR A51A

A57     LD A,B:CP 2;     LD 12,1
        JR Z,AE7_2
        LD (HL),D:INC L
        LD D,E:LD E,6
        CALL A22
        JR A54

A57A    LD (HL),D:INC L;LD 12,10
        LD (HL),#36:INC L
        LD (HL),E : INC L
        JP A28

A58     LD A,E:ADD A,C;EX 3,3
        CP #30:JR NZ,AE7_2
        CP E : JR Z,AE7_2
        CP C : JR Z,AE7_2
        LD (HL),#EB:INC L
        RET

A59     DEC B;           EX 7,3
        JR NZ,AE7_2
A60     LD (HL),#E3:INC L:RET

A61     LD (HL),B:INC L; EX 7,4
        JR A60

A62A    LD (HL),B:INC L; AAS 1,2
A62     LD A,D:CP 3;     AAS 1,1
        JR NZ,AE7_2
        LD A,C:ADD A,LY
A63     LD (HL),A:INC L:RET

A64     LD A,D:CP 3;    AAS 1,10
        JR NZ,AE7_2
        LD A,LY:ADD A,#46
        LD (HL),A:INC L
        JP A28

AE7_2   JP AE7

A65     LD A,D:CP 3;    AAS 1,12
        JR NZ,AE7_2
        LD (HL),B:INC L
        LD A,LY : ADD A,6
A65A    LD (HL),A:INC L
        LD (HL),C:INC L
        RET

A66     LD A,LY:CP #80; AAS 3,3
        JR NZ,A71
        DEC D:JR NZ,A68
A67     LD A,C:ADD A,9:JR A63

A68     LD A,E:CP #10
        JR NZ,AE7_2
        DEC B:JR NZ,AE7_2
        LD (HL),#EB:INC L
        LD (HL),#19:INC L
        LD (HL),#EB:INC L
        RET

A69     LD A,LY:CP #80; AAS 4,3
        JR NZ,AE7_2
        DEC B:JR Z,AE7_2
        LD (HL),D:INC L
        JR A67

A70     LD A,LY:CP #80; AAS 4,4
        JR NZ,AE7_2
        LD A,D:CP B
        JR NZ,AE7_2
        LD (HL),A:INC L
        LD (HL),#29:INC L
        RET

A71     DEC D:JR NZ,AE7_2
        LD A,LY:SUB #88:RRCA
        NEG:ADD A,#4A:ADD A,C
        LD C,A:LD A,#ED
        JR A65A

A72     LD (HL),#CB:INC L
;                       BRS 10,1
A73     LD A,D:OR A
        JR NZ,A74
        LD A,E:CP 8
A74     JP NC,AE8
        RLCA:RLCA:RLCA
        ADD A,LY:ADD A,C
        LD (HL),A:INC L
        RET

A75     LD (HL),B : INC L
;                      BRS 10,12
        LD (HL),#CB:INC L
        LD (HL),C : INC L
        LD C,6:JR A73

AE8     LD A,8:JP ASERR

A76     JR A85;RST
A78     CP 10:JR NZ,AE7_3
        LD A,H:OR A:JR NZ,AE8
        LD A,L
        AND #C7:JR NZ,AE8
        LD A,L
        OR #C7
A79     LD (IX),A:INC LX:RET

A80     JR A84;IM
A81     CP 10:JR NZ,AE7_3
        LD A,H:OR A:JR NZ,AE8
        LD A,L:CP 3
        JR NC,AE8
        OR A:JR Z,A82
        INC A
A82     RLCA:RLCA:RLCA
        ADD A,#46
        LD (IX),#ED:INC LX
        JR A79

A83     JR A84;DJNZ
        CP 10:JR NZ,AE7_3
        LD A,#10:JR A91

A84     INC LX
A85     INC LX:RET

A86     JR A85;RET
        OR A:JR Z,A87
        CP 9:JR Z,A86A
        DEC A:DEC L:OR L
        JR NZ,AE7_3
        LD L,#18
A86A    LD A,L:ADD A,#C0:JR A79

A87     LD A,#C9:JR A79

A88     CP 9:JR NZ,A84
        CALL ASPEL
        JR A84

AE7_3   JP AE7

A89     JR A88; JR
        CP 9:LD B,#F8:JR NZ,A90
        DEC H:JR Z,AE7_3
        LD B,L
        PUSH BC:CALL AZ:POP BC
A90     CP 10:JR NZ,AE7_3
        LD A,B:ADD A,#20
A91     LD (IX),A:INC LX
        LD BC,(ASADR):INC BC
        LD A,C:ADD A,LX:LD C,A
        JR NC,A91B
        INC B
A91B    OR A:SBC HL,BC
        LD A,H:OR A
        JR Z,A92
        INC A:JR NZ,A93
        LD A,L
        CP #80:JR C,A93
A91A    LD (IX),A:INC LX:RET

A92     LD A,L
        CP #80:JR C,A91A
A93     LD A,9:JP ASERR

A94     DEC A:JR Z,A95B
        CP 11:JR Z,A84
        CP 8 :JR NZ,A95
A95A    CALL ASPEL
A95     INC LX:JP A84

A95B    DEC L:JP NZ,A85
        JR A95A

A96     JR A94; JP
        CP 1:JR Z,A98A
        CP 12:JR Z,A100
        CP 9 :LD B,#C3
A97A    JR NZ,A97
A97D    LD A,L:ADD A,LY
        PUSH AF:CALL AZ:POP BC
A97     CP 10
        JR NZ,AE7_4
A97B    LD (IX),B:INC LX
A97C    LD (IX),L:INC LX
        LD (IX),H:INC LX
        RET

A98A    DEC L:LD L,#18:JR Z,A97D
A98     LD A,H:CP 2
        JR NZ,AE7_4
A99     LD (IX),#E9:INC LX
        RET

A100    LD A,L:OR A
        JR NZ,AE7_4
        LD (IX),H:INC LX
        JR A99

A101    CP 9:JR Z,A95A
        DEC A:JR NZ,A95
        DEC L:JR NZ,A95
        JR A95A

A102    JR A101;        CALL
        CP 9:JR Z,A97D
        LD B,#CD
        CP 1:JR NZ,A97
        DEC L:JR NZ,AE7_4
        LD L,#18:JR A97D

A103    CP 11:JR Z,A106A
        LD A,(DE)
        CP #77:JR Z,A103A
        OR #5F:INC A:JR NZ,A106A
A103A   CALL ASPEL:JR A106A

AE7_4   JP AE7

A104    JR A103;IN
        CP 11:JR Z,A105A
        DEC A:JR NZ,AE7_4
        LD A,L:CP 6
        JR Z,AE7_4
        LD A,(DE)
        CP #77:JR Z,A107
        OR #5F:INC A
        JR NZ,A107B
        LD A,L:CP 7:JR NZ,AE7_4
        CALL AZ
A105A   LD C,#DB
A105    LD A,H:OR A:JP NZ,AE8
A106    LD (IX),C
        LD (IX+1),L
A106A   INC LX:INC LX:RET

A107    INC DE
A107B   LD A,L
A107A   RLCA:RLCA:RLCA
        ADD A,LY
        LD L,A:LD C,#ED
        JR A106

A108A   DEC A:JR Z,A106A
        CALL ASPEL
        JR A106A

A108    JR A108A;OUT
        DEC A:JR Z,A109A
        CP 7 :JR Z,A109
        CP 10:JR NZ,AE7_4
        PUSH HL
        CALL AZ
        LD B,L
        POP HL
        OR A:JR Z,A108B
        DEC A :JR NZ,AE7_4
        LD A,B:CP 7
        JR NZ,AE7_4
A108B   LD A,H:OR A:JP NZ,AE8
        LD C,#D3:JR A106

A109    CALL AZ
        DEC A :JR NZ,AE7_4
A109A   LD A,H:CP 2
        JR NZ,A107B
        JR AE7_4

A110    JR A106A;DW
        CP 10:JP Z,A97C
        JP AE7_4

; .DE-TEXT XL+(ASADR)=$
AZA     LD A,(PASS):PUSH AF
        LD A,#FF:LD (PASS),A
        CALL AZ
        EX AF,AF
        POP AF:LD (PASS),A
        EX AF,AF
        RET

AZ      LD A,(DE)
        SUB #30:JR C,AZ2
        CP #10 :JR C,AZ1
        CP #3F :JR C,AZ2
        CP #50 :JR NC,AZ3
        SUB #2F
AZ1     INC DE
        LD B,A:ADD A,A:ADD A,B
        LD L,A:LD H,ASTB2/256
        LD A,(HL):INC L
        LD B,(HL):INC L
        LD L,(HL):LD H,B
        RET

AZ2     XOR A:RET

AZ3     LD A,(PASS):OR A
        LD A,(DE):INC DE
        JR NZ,AZ4
        LD H,A:CALL ASPA:LD A,H
        CP #C0
        LD A,10:RET NC
        BIT 5,H:RET Z
        INC A
        BIT 4,H:RET Z
        INC A
        RET

AZ4     CP #C0:JR C,AZ10
        CP #DC:JR C,AZ9
        JR Z,AZ8
        CP #E7:JR C,AZ7
        LD B,0
        SUB #F3:JR NC,AZ5
        DEC B
AZ5     LD C,A
        LD HL,(ASADR)
        LD A,L:ADD A,LX:LD L,A
        JR NC,AZ5A
        INC H
AZ5A    ADD HL,BC
AZ6     LD A,10:RET

AZ7     SUB #DD:LD L,A:LD H,0
        JR AZ6

AZ8     LD A,10:CALL ASERR
        EX DE,HL:CALL ASPSTR:EX DE,HL
        JR AZ6

AZ9     DEC DE
AZ9C    EX DE,HL:CALL FLABEL:EX DE,HL
        LD A,10:RET

AZ10    LD HL,0
        LD B,A
        CP #B0 :JR NC,AZ10D
        BIT 3,A:JR Z,AZ10A
        AND #07:JR Z,AZ10H
        CP 3:JR NZ,AZ10E
        PUSH BC:CALL AZ9C:POP BC
        JR AZ10F

AZ10E   LD H,0
        LD A,(DE):INC DE:LD L,A
        JR C,AZ10F
        LD A,(DE):INC DE:LD H,A
AZ10F   LD A,B:OR #6F:INC A
        LD A,B
        JR NZ,AZ10G
        LD B,H :LD C,L
        LD HL,0:SBC HL,BC
AZ10G   BIT 5,A
        LD A,10
        RET Z
        INC A:RET

AZ10H   LD A,B:JR AZ10A

AZ10D   AND #07:JR Z,AZ10B
        AND #03:JR Z,AZ10C
        BIT 2,B:JR Z,AZ10C
        OR #10
AZ10C   OR #08
AZ10A   PUSH BC
        PUSH IX
        AND #1F
        LD C,A
        XOR A:LD (ASFNON),A
        LD A,C
        LD HX,16
        LD C,PRPLUS
AZ10K   CALL AZ15
        LD C,A:OR A
        LD A,(DE):INC DE
        JR NZ,AZ10K
        DEC DE
        POP IX
        POP BC
AZ10B   LD A,10
        BIT 5,B:RET Z
        INC A
        BIT 4,B:RET Z
        LD A,H:OR A:JR Z,AZ12
        INC H :JR NZ,AZ11
        LD A,L:CP #80:JR NC,AZ13
AZ11    LD A,9:CALL ASERR
        JR AZ13

AZ12    LD A,L:CP #80:JR NC,AZ11
AZ13    LD H,#DD:LD A,12
        BIT 3,B:RET Z
        LD H,#FD
        RET

AZ14A   LD HL,0:LD C,PRPLUS
AZ14    LD A,(DE):INC DE
AZ15    PUSH HL
        LD B,A
        OR #0F:INC A
        JR Z,AZ19
        LD A,B:AND #07
        JR NZ,AZ16
        DEC HX:JP Z,GERR
        PUSH BC:CALL AZ14A:POP BC
        INC HX
        JR AZ19

AZ16    EX DE,HL
        CP 3:JR NZ,AZ17
        LD A,(HL):OR A:JR Z,AZ16A
        PUSH BC:CALL FLABEL:POP BC
        JR AZ18

AZ16A   INC HL:LD DE,(ASADR)
        LD A,E:ADD A,LX:LD E,A
        JR NC,AZ18
        INC D:JR AZ18

AZ17    LD E,(HL):INC HL
        LD D,0:JR C,AZ18
        LD D,(HL):INC HL
AZ18    EX DE,HL
AZ19    XOR A:BIT 3,B:JR NZ,AZ22
AZ19A   LD A,(DE):OR #0F:INC A
        LD A,(DE)
        JR NZ,AZ20
        AND #07:ADD A,#0F
        JR AZ21

AZ20    RRCA:RRCA:RRCA:RRCA:AND #0F
AZ21    PUSH HL
        ADD A,#63
        LD L,A:LD H,ASTB2/256
        LD A,(HL)
        POP HL
        INC C:CP C:DEC C
        JR C,AZ22
        DEC HX:JP Z,GERR
        PUSH BC
        LD C,A
        CALL AZ14
        POP BC
        INC HX
        OR A:JR NZ,AZ19A
AZ22    EX AF,AF
        LD A,B
        PUSH BC:EX (SP),HL
        POP BC :EX (SP),HL
        PUSH DE
        CALL AZ23
        POP DE
        POP BC
        EX AF,AF
        CP C:JP Z,AZ14
        RET

AZ23    EX DE,HL
        LD L,A
        OR #0F:INC A:LD A,L
        JR NZ,AZ24
        AND #07:ADD A,#0F
        JR AZ25

AZ24    RRCA:RRCA:RRCA:RRCA:AND #0F
AZ25    ADD A,A:ADD A,#D0
        LD L,A:LD H,ASTB1/256
        LD A,(HL):INC L
        LD H,(HL):LD L,A
        PUSH HL:EX DE,HL:RET

ASADD   ADD HL,BC:RET

ASHIGH  LD L,H
ASLOW   LD H,0:RET

ASUP    LD A,L:OR A:RET Z
        INC H
ASDOWN  LD L,0:RET

ASFON   LD A,(ASFNON):OR A
        JR NZ,ASFON1
        LD (ASFONV),HL
        LD HL,0:LD (ASFONE),HL
ASFON1  LD E,A:LD D,0
        LD HL,(ASFONV)
        OR A:SBC HL,DE
        JR NZ,ASFON2
        LD (ASFONE),BC
ASFON2  INC A:LD (ASFNON),A
        LD HL,(ASFONE)
        RET

ASNEG   LD B,H:LD C,L
        LD HL,0
ASSUB   OR A:SBC HL,BC:RET

ASNOT   LD A,H:OR L:JR Z,ASNOT2
ASNOT1  LD HL,0:RET

ASNOT2  INC L:RET

ASML256 LD H,L:LD L,0:RET

ASAND   LD A,H:AND B:LD H,A
        LD A,L:AND C:LD L,A
        RET

ASOR    LD A,H:OR B:LD H,A
        LD A,L:OR C:LD L,A
        RET

ASXOR   LD A,H:XOR B:LD H,A
        LD A,L:XOR C:LD L,A
        RET

ASSHL   LD A,B:OR C:RET Z
        ADD HL,HL:DEC BC:JR ASSHL

ASSHR   LD A,B:OR C:RET Z
        SRL H:RR L:DEC BC:JR ASSHR

ASMOE   OR A:SBC HL,BC
        JR Z,ASMOE1
        JR NC,ASNOT1
ASMOE1  LD HL,1:RET

ASBOE   OR A:SBC HL,BC
        JR NC,ASMOE1
        JR ASNOT1

ASMEN   OR A:SBC HL,BC
        JR C,ASMOE1
        JR ASNOT1

ASBOL   OR A:SBC HL,BC
        JR Z,ASNOT1
        JR NC,ASMOE1
        JR ASNOT1

ASEQUAL OR A:SBC HL,BC
        JR Z,ASMOE1
        JR ASNOT1


ASMUL   LD A,16:EX DE,HL
ASMUL1  ADD HL,HL:RL E:RL D
        JR NC,$+3:ADD HL,BC
        DEC A:JR NZ,ASMUL1
        RET

ASDIV   EX DE,HL
        LD A,17:LD HL,0
        JR ASDIV3

ASDIV1  ADC HL,HL
        SBC HL,BC
        JR NC,ASDIV2
        ADD HL,BC
ASDIV2  CCF
ASDIV3  RL E:RL D
        DEC A
        JR NZ,ASDIV1
        EX DE,HL:RET

ASMOD   CALL ASDIV:EX DE,HL:RET

;. .C- .

ASPEL   LD A,(DE)
        CP #30:RET C
        CP #40:JR C,ASPEL1
        CP #6F:RET C
        OR A : JP M,ASPA0
ASPEL1  INC DE:OR A:RET

; 
ASPL    EX DE,HL
        XOR A
ASPL0   OR (HL):INC HL:JP P,ASPL0
        EX DE,HL
        RET

;. .
ASPSTR  XOR A
ASPS1   CP (HL):INC HL:JR NZ,ASPS1
        RET ;NC

;. .
ASPA0   INC DE
ASPA    CP #C0:JR C,ASPA2
        CP #DC:JR C,ASPL
        JR Z,ASPA1
        RET ;NC

ASPA1   EX DE,HL:CALL ASPSTR:EX DE,HL
        RET

ASPA2   LD C,16
        CP #B0 :JR C,ASPA3
        AND #07:RET Z
        AND #03:OR #08
ASPA3   LD B,A
        OR #0F:INC A
        JR Z,ASPA6
        LD A,B:AND 7
        JR NZ,ASPA4
        DEC C:JP Z,GERR
        PUSH BC
        CALL ASPA7
        POP BC:INC C
        JR ASPA6

ASPA4   CP 3:JR C,ASPA5
        JR Z,ASPA8
        INC DE
ASPA5   INC DE
ASPA6   BIT 3,B:JR NZ,ASPA10
ASPA7   LD A,(DE):INC DE
        JR ASPA3

ASPA8   LD A,(DE):INC DE
        SUB #C0
        CP #1C:JR NC,ASPA6
        EX DE,HL:XOR A
ASPA9   OR (HL):INC HL:JP P,ASPA9
        EX DE,HL
        JR ASPA6

ASPA10  OR A:RET

;  HL-ADR
;NC     DE-EQU
;C  A=0 NO_LBL
;C  A=1 DOUBLE LBL
;C  A=2 NO_SPC

FLABEL  LD (FLUSP),SP
        LD SP,HL
        POP HL
        LD (FLFIRST),HL
        LD A,L
        ADD A,A:ADD A,A:ADD A,A
        LD L,A
        RES 6,H
        XOR H
        BIT 7,H
        JR NZ,FL2
        INC L
        POP BC
        RLCA:XOR C
        BIT 7,C
        JR NZ,FL1
        INC L
        RLCA:XOR B
        BIT 7,B
        JR NZ,FL2
        INC L
        POP DE
        RLCA:XOR E
        BIT 7,E
        JR NZ,FL1
        INC L
        RLCA:XOR D
        BIT 7,D
        JR NZ,FL2
        INC L
        EXX
        POP BC
        RLCA:XOR C
        BIT 7,C
        EXX
        JP Z,GERR
FL1     DEC SP
FL2     LD (FLUSP1),SP
        LD (FL2A+1),HL
        EXX
        LD L,A
        LD BC,#7FFD
        LD A,ASBLBL:OUT (C),A
FL2A    LD BC,#0101
        LD H,ABLABEL/2
        ADD HL,HL:LD SP,HL
        POP DE
        BIT 7,D
        JP Z,FL14
        LD A,C
        EXX
        AND #07
        ADD A,A:ADD A,#C4
        LD L,A :LD H,ASTB1/256
        LD SP,HL
        POP HL
        LD (FL4A+1),HL
FL3     EXX
FL4     LD A,D
        OR #40
        JP P,FL13
        LD D,A
        EX DE,HL
        LD SP,HL
        POP DE:POP HL
FL4A    JP 0

FL5     LD A,L:CP C
        JR NZ,FL4
        JR FL10

FL6     SBC HL,BC
        JR NZ,FL4
        JR FL11

FL7     SBC HL,BC
        JR NZ,FL4
        EXX
        POP HL:LD A,L:CP C
        JR NZ,FL3
        EXX:JR FL10

FL8     SBC HL,BC
        JR NZ,FL4
        EXX
        POP HL:SBC HL,BC
        JR NZ,FL3
        EXX:JR FL11

FL9     SBC HL,BC
        JR NZ,FL4
        EXX
        POP HL:SBC HL,BC
        JR NZ,FL3
        POP HL:LD A,L:CP E
        JR NZ,FL3
        EXX:JR FL10

FL9A    SBC HL,BC
        JR NZ,FL4
        EXX
        POP HL:SBC HL,BC
        JR NZ,FL3
        POP HL:SBC HL,DE
        JR NZ,FL3
        EXX:JR FL11

FL10    DEC SP
FL11    LD A,C:AND #07
        ADD A,2:NEG
        LD L,A:LD H,#FF
        ADD HL,SP
        SET 6,(HL)
        POP DE; EQU
        LD A,(FLFIRST+1)
        AND #40:JR Z,FL11A
        LD A,2
FL11A   LD BC,#7FFD:LD H,ASBTXT
        OUT (C),H
        LD SP,(FLUSP)
        LD HL,(FLUSP1)
        OR A:RET Z
        JP ASERR

FL17    LD A,3
FL17A   JR FL11A

FL13    OR #80
        CP ABLABEL
        JR C,FL18
        LD D,A
        EX DE,HL
        LD SP,HL
        POP DE
FL14    LD A,(FLFIRST+1)
        BIT 6,A
        LD HL,(AELBL)
        JR Z,FL14B
        LD A,D:OR #BF
        AND H:LD H,A
        PUSH HL
        SET 6,H
        LD (HL),L
        LD A,H
        INC HL
        AND #3F
        LD (HL),A:INC HL
        LD A,C:AND #07
        LD (HL),C:INC HL:JR Z,FL16
        LD (HL),B:INC HL
        DEC A:JR Z,FL16
        LD (FL16A+1),HL
        EXX
FL16A   LD HL,0
        LD (HL),C:INC HL
        DEC A:JR Z,FL16
        LD (HL),B:INC HL
        DEC A:JR Z,FL16
        LD (HL),E:INC HL
        DEC A:JR Z,FL16
        LD (HL),D:INC HL
FL16    LD (AEQULBL),HL
        LD DE,(ASADR)
        LD A,E:ADD A,LX
        LD (HL),A:INC HL
        JR NC,FL14A
        INC D
FL14A   LD (HL),D:INC HL
FL14B   LD A,H:OR A
        JR Z,FL17
        LD (AELBL),HL
        LD A,(FLFIRST+1)
        OR #BF:INC A
        JR Z,FL11A
FL18    LD A,1:JR FL17A

EEE
