ONGET   PUSH HL
        CALL CUROFF
        CALL WTKPR
        POP HL
        LD A,(RAWKEY)
        LD DE,4
        LD B,(HL)
        INC HL
ONGT2   CP (HL):RET Z
        ADD HL,DE
        DJNZ ONGT2
        CALL PRSTAT
        SCF
        RET

MBSCHD  LD HL,(ETEXT):DEC HL,HL
        LD E,(HL):INC E
        XOR A:LD D,A
        RET

SCREPOS ;HL,AdrBegOfLine C,#ScrLine
        CALL SCRP0
        CALL PRNLINE
RETHINK CALL RESCAT,PSCR
REFRESH EI:HALT:DI:JP PRSCR

SCRP0   LD IY,0:LD (ABLINE),HL
        XOR A:LD D,A:DEC HL
        LD E,(HL):INC E:JR Z,SCRP2
SCRP1   RES 6,E:INC IY
        SBC HL,DE:LD E,(HL)
        INC E:JP NZ,SCRP1
SCRP2   LD (NLINE),IY
        LD A,HY:OR A:JR NZ,SCRP3
        LD A,LY:CP HGT-1
        JR NC,SCRP3
        INC A:LD C,A
SCRP3   LD A,C:LD (PY),A
NEWLINE CALL INIT2A
        JP MVBUF

RESCAT  LD HL,CACHEST
        RES 0,(HL)
        RET

RESBLK  LD DE,MBSTAT:LD A,(DE)
        AND #F9:LD (DE),A
MRET    RET

CLTXN   LD HL,TXNAME,B,8
FILLB   LD (HL),#20:INC HL
        DJNZ $-3
        RET

;HL,BUF A-X C,LEN/4
EDITOR  LD DE,(PX)
        PUSH DE,HL
        LD (PX),A
        LD A,TLINE:LD (PY),A
        LD A,C:LD (ED1+1),A
        RLC C,C:LD LY,C
        CALL EDFILL:LDIR
        LD HL,PX
        CALL EDELN
        CALL CURON
ED0A    LD C,0
ED0     LD A,(IX)
        XOR C
        LD (IX),A
        LD DE,(TLINE')+1
ED1     LD C,0
        LD A,1
        LD HL,BUFF32
        PUSH IY
        CALL PRSTRI,PRSTAT
        POP IY
ED2     CALL WTKPR
        LD A,(LASTK):LD B,A
        CP #14:JP C,ED5;CTRL
        LD HL,PX
        PUSH HL
        CALL EDOFS
        LD E,(BUFF32])+31
        LD L,E:DEC L
        LDDR : LD (DE),A
        POP HL
        CALL EDRGT
        JR ED0A
ED5     LD HL,PX:LD C,0
        CP 1:JR NZ,ED6
        LD C,4
ED6     CP 19:JR NZ,ED7
        LD C,2
ED7     CP 8:CALL Z,EDLFT
        CP 9:CALL Z,EDRGT
        CP 10:JR NZ,ED9
        CALL EDFILL
        LD (HL),B
ED9     CP 12:JR NZ,ED10
        CALL EDLFT
        JR C,ED10:CALL EDDEL
ED10    CP 15:CALL Z,EDDEL
        CP 16:JR NZ,ED12
        LD (HL),0;BLINE
ED12    CP 17:CALL Z,EDELN
        CP 7:JR NZ,ED13
        LD E,A
        LD A,(DRIVE)
        INC A:AND 3
        LD (DRIVE),A
        LD A,E
ED13    CP 14:JR Z,ED20
        OR A:JR Z,ED20
        CP 13:JP NZ,ED0
        LD HL,BUFF32
        POP DE
        LD C,LY:LD B,0
        LDIR:OR A;NZ
        JR $+3
ED20    POP HL:PUSH AF
        CALL CUROFF
        POP AF,HL
        LD (PX),HL
        RET

EDELN   LD B,(HL)
        PUSH HL:EXA
        LD H,BUFF32[
        LD A,LY:LD B,A
        ADD A,(BUFF32])-1
        LD L,A
        CALL FNLAST
        POP HL:EXA
        LD (HL),B
        RET

EDDEL   PUSH HL,BC,AF
        CALL EDOFS
        LD A,E
        ADD A,BUFF32]
        LD E,A:LD L,E
        INC L:LDIR
        LD A,#20:LD (DE),A
        POP AF,BC,HL
        RET

EDOFS   LD A,31:SUB (HL)
        LD C,A:LD E,(HL)
        LD H,BUFF32[,D,H
        LD A,B:LD B,0
        RET
EDLFT   DEC (HL):RET P
        INC (HL):SCF
        RET

EDRGT   LD E,A
        INC (HL)
        LD A,(HL)
        CP LY:LD A,E
        RET C
        DEC (HL)
        RET

EDFILL  EX DE,HL
        LD HL,BUFF32
        PUSH HL
        LD B,#20:CALL FILLB
        POP HL
        EX DE,HL
        RET

;HL-MESS DE-ED BUFF
REQ6    PUSH DE
        CALL PUTMSG
        POP HL
        LD C,6
        CALL LOWEDIT
        RET NZ
        POP AF:RET

LOWEDIT PUSH HL,BC
        CALL LOWED1
        LD HL,#3E20
        LD B,L,C,L
        LD DE,TLINE',A,1
        CALL PRINT4
        POP BC,HL
        XOR A
        CALL EDITOR
        EXA
LOWED1  LD A,(LECOL)
        OR #40
        LD (LEADR),A
        EXA
        RET

DSINP   CALL PUTMSG:INC HL
        LD C,(HL):LD B,0
        ADD HL,BC
        LD C,2
        CALL LOWEDIT
        PUSH AF
        CALL CLRMSG2
        POP AF
        RET NZ
        POP AF
        RET

CLRMSG  LD HL,CLRMES
        CALL LOWED1
PUTMSG  LD DE,MLINE'
        LD A,2:LD C,7
        CALL PRSTRI
        EX DE,HL
        LD HL,LECOL
        LD A,(LEADR)
        CP (HL)
        EX DE,HL
        RET Z
CLRMSG2 PUSH HL
        LD A,(LECOL)
        LD (LEADR),A
        LD HL,CLRMES
        LD DE,TLINE'
        LD A,1:LD C,7
        CALL PRSTRI
        POP HL
        RET

;HL,TEXT 0=END DE,POS A,OFS C,FULLlen/4

PRSTRI  LD LY,E:LD HY,C
        LD (PSTR4+1),A
        LD A,D:LD (PSTR3+1),A
PSTR0   XOR A:OR (HL):JR Z,PSTR1
        LD D,(HL):INC HL
        XOR A:OR (HL):JR Z,PSTR1+2
        LD E,(HL):INC HL
        XOR A:OR (HL):JR Z,PSTR1+4
        LD B,(HL):INC HL
        XOR A:OR (HL):JR Z,PSTR1+6
        LD C,(HL):INC HL
        JR PSTR2
PSTR1   LD D,#20,E,#20
        LD B,#20,C,#20
        LD A,HY:OR #80:LD HY,A
PSTR2   PUSH HL
        EX DE,HL
PSTR3   LD D,0
        LD A,LY:LD E,A
PSTR4   LD A,2
        CALL PRINT4
        POP HL
        LD A,LY:ADD A,3:LD LY,A
        DEC HY:LD A,HY
        AND #7F:RET Z
        LD A,HY
        AND #80:JR Z,PSTR0
        JR PSTR1

;WIND  DE,YX BC,HL A,COLOR
WIND    LD (WND2+1),A
        LD A,D:OR #40
        AND #F8:LD H,A
        LD A,D
.3      RRCA
        AND #E0:OR E
        LD L,A
        PUSH HL,BC
        LD D,C:DEC C,C
        LD E,C:LD A,B
.3      ADD A,A
        SUB 2:LD C,A
        PUSH HL
        CALL WND4
        POP HL
        INC H
WND1    PUSH HL
        LD (HL),#80:INC L
        XOR A:LD B,E
        LD (HL),A:INC L
        DJNZ $-2
        LD (HL),#01
        POP HL
        INC H:LD A,H
        AND 7:JR NZ,WND1A
        LD A,L:ADD A,#20
        LD L,A:JR C,WND1A
        LD A,H:SUB 8:LD H,A
WND1A   DEC C:JR NZ,WND1
        CALL WND4
        POP BC,HL
        LD A,H:AND #18
.3      RRCA
        OR #58:LD H,A
        LD A,#21
        SUB C:LD E,A
        LD D,0
WND2    LD A,0
        LD HY,C:LD C,B
WND3    LD B,HY
        CALL WND5
        DEC L:ADD HL,DE
        DEC C:JR NZ,WND3
        RET

WND4    LD B,D:LD A,#FF
WND5    LD (HL),A:INC L
        DJNZ $-2
        RET

CLWIND  CALL CLWD0
        JP PRSCR

CLWD0   LD HL,#4020
        LD DE,#0700-31
        LD C,HGT
CLWD1   CALL CLWD3:ADD HL,DE
        CALL CLWD3
        INC H,L:JR Z,CLWD2
        LD A,H:SUB 8:LD H,A
CLWD2   DEC C:JR NZ,CLWD1
        JP TXATR
CLWD3   LD (HL),#80:INC L
        LD B,7:XOR A
.4      LD (HL),A:INC L
        DJNZ $-8
.2      LD (HL),A:INC L
        LD (HL),#01
        RET

;HL-ADDR
;BC-LEN
;DE-NAME
;         NC-OK
;      C A=0-ERR
;      C A=1-BREAK
;      C A=4-NO_SPACE

FILESV  PUSH HL:PUSH DE:PUSH BC
        LD A,(SAVEMD):AND #03
        CALL FILEKL
        POP BC:POP DE:POP HL
        JR NC,FLSV1
        CP 2:SCF:RET NZ
FLSV1   LD A,(CATBF+#08E4)
        CP #80:JR Z,FLSV2A
        LD A,(CATBF+#08E6)
        OR A:JR NZ,FLSV2
        LD A,(CATBF+#08E5)
        CP B:JR C,FLSV2A
        JR NZ,FLSV2
        LD A,C:OR A
        JR Z,FLSV2
FLSV2A  LD A,4:SCF:RET

FLSV2   LD A,C:OR A
        LD A,B
        JR Z,FLSV3
        INC A
FLSV3   OR A:RET Z
        PUSH BC,DE,HL
        LD B,A
        LD C,6
        LD DE,(CATBF+#08E1)
        CALL DOS
        POP HL,DE,BC
        RET C
;BC-LEN; DE-NAME; HL-ADR
FLSV4   PUSH HL:PUSH BC
        LD A,(CATBF+#08E4)
        LD H,0:LD L,A
.4      ADD HL,HL
        LD A,H:ADD A,CATBF/256:LD H,A
        EX DE,HL
        LD BC,9
        LDIR
        EX DE,HL
        POP BC:POP DE
        LD (HL),E:INC HL
        LD (HL),D:INC HL
        LD (HL),C:INC HL
        LD (HL),B:INC HL
        LD A,C:OR A
        JR Z,FLSV5
        INC B
FLSV5   LD (HL),B:INC HL
        LD DE,(CATBF+#08E1)
        LD (HL),E:INC HL
        LD (HL),D:INC HL
        LD (HL),0
        LD HL,CATBF+#08E4
        INC (HL)
        LD HL,(CATBF+#08E5)
        LD C,B:LD B,0
        OR A:SBC HL,BC
        LD (CATBF+#08E5),HL
        LD HL,(CATBF+#08E1)
        LD A,L:ADD A,C:LD C,A
.4      RRA
        AND #1F:ADD A,H:LD H,A
        LD A,C:AND #0F:LD L,A
        LD L,A:LD (CATBF+#08E1),HL
        JP SAVECAT

;DE-NAME
;A(0,1) MODE
;A(7)=0 NO_WRCAT
;A(7)=1 WRCAT
;
;         NC-OK
;      C A=0-ERR
;      C A=1-BREAK
;      C A=2-NO_FILE

FILEKL  LD (KLMODE),A
        CALL FILEFND:RET C
        LD A,(KLMODE)
        AND 3:RET Z
        DEC A:JR Z,FLK4
        DEC A:JR Z,FLK3
        CALL FLK1
        JR FLK6

FLK1    PUSH BC
        LD HL,#0010:ADD HL,BC
        CALL FLFN2
        JR C,FLK2
        EXX
        POP BC
        CALL FLK7
        EXX
        JR FLK1

FLK2    POP BC:RET

FLK3    CALL FILEFL1
        JR FLK5

FLK4    CALL FLK1
FLK5    CALL FLK7
FLK6    LD A,(KLMODE)
        AND #80:RET Z
SAVECAT LD HL,CATBF
        LD DE,0
        LD BC,#0906
        JP DOS

FLK7    LD A,1:LD (BC),A
        LD HL,CATBF+#08F4
        LD E,(HL):INC E:LD (HL),E
        LD HL,#0010
        ADD HL,BC
        LD A,(HL):OR A
        RET NZ
        LD C,E; DEL
        LD A,(CATBF+#08E4); ALL
        LD B,A
        EXX
        LD HL,(CATBF+#08E5)
        LD D,0
        EXX
FLK8    EX DE,HL
        LD HL,-#0010
        ADD HL,DE
        LD A,(HL)
        CP 1:JR NZ,FLK9
        DEC (HL)
        DEC DE:DEC DE:DEC DE
        LD A,(DE)
        EXX
        LD E,A
        ADD HL,DE
        EXX
        DEC C
        DJNZ FLK8
        EX DE,HL
FLK9    XOR A:LD (DE),A
        LD HL,#000E
        ADD HL,DE
        LD E,(HL):INC HL
        LD D,(HL)
        LD (CATBF+#08E1),DE
        EXX
        LD (CATBF+#08E5),HL
        EXX
        LD A,B:LD (CATBF+#08E4),A
        LD A,C:LD (CATBF+#08F4),A
        RET

;DE-NAME HL-ADDR
;BC-TOP SIZE
;
;         NC-OK, BC-LEN
;      C A=0-ERR
;      C A=1-BREAK
;      C A=2-NO_FILE
;      C A=3-TOO_BIG

FILELD  PUSH HL,BC
        CALL FILEFL
        POP BC,DE
        RET C
        LD A,C:CP (HL)
        LD C,(HL):INC HL
        LD A,B:SBC A,(HL)
        LD A,3:RET C
        LD B,(HL):INC HL
        INC HL
        LD A,(HL):INC HL
        LD H,(HL):LD L,A
        EX DE,HL
        LD A,B:OR A:JR Z,FILELD1
        PUSH BC,HL
        LD C,5:CALL DOS
        POP HL,BC
        RET C
        LD DE,(SECTR)
FILELD1 LD A,C:OR A:RET Z
        PUSH BC,HL
        LD HL,BUF1024
        LD BC,#0105
        CALL DOS
        POP HL,BC
        RET C
        PUSH BC
        LD E,0:LD D,B
        ADD HL,DE
        LD B,E
        EX DE,HL
        LD HL,BUF1024
        LDIR
        POP BC
        XOR A:RET

;DE-NAME   NC   - OK
;OK: DE-NAME, BC-ADESCR, HL-ADESCR+11
;      C A=0-ERR
;      C A=1-BREAK
;      C A=2-NO_FILE


FILEFL  CALL FILEFND
        RET C
FILEFL1 PUSH HL,BC
        LD BC,5:ADD HL,BC
        CALL FLFN2
        JR C,FILEFL2
        POP AF,AF
        JR FILEFL1

FILEFL2 POP BC,HL:XOR A:RET


;***************************************
;DE-NAME    NC-OK
;        C A=0-ERR
;        C A=1-BREAK
;        C A=2-NO_FILE

FILEFND LD HL,CACHEST
        XOR A
        BIT 0,(HL)
        PUSH DE,HL
        LD C,1:LD B,0:CALL Z,DOS
        POP HL,DE
        RET C
        SET 0,(HL)
FLFN1   LD HL,CATBF
FLFN2   LD A,(HL)
        OR A
        LD A,2:SCF:RET Z
        LD C,L
        PUSH DE
        LD B,9;# OF CHARS
FLFN3   LD A,(DE):CP (HL)
        JR NZ,FLFN4
        INC DE,HL
        DJNZ FLFN3
        POP DE
        LD B,H:INC HL,HL
        XOR A
        RET

FLFN4   LD L,#10:LD B,0
        ADD HL,BC
        POP DE:JR FLFN2

;***************************************
;#3D13 EMULATOR  !뢠!
; C=0 RDCAT C=1 SELDRV(B)+RDCAT
; C=5 LOAD  C=6 SAVE
;
; NC-OK
; C,A=0-ERROR
; C,A=1-ABORT

DOS     XOR A
DOS2    DI:IM 1:LD IY,#5C3A
        PUSH IX
        CALL DOS4
        POP IX
        IM 2
        EX AF,AF
        XOR A:OUT (#FE),A
        EX AF,AF
        RET NC
        OR A :JR Z,ABORT
        DEC A:JR Z,NODRV
        DEC A:JR Z,NODSK
        DEC A:JR Z,NONTRD
        DEC A:JR NZ,ABRT2
        LD HL,DSKERRM:CALL WRN
DSKERR1 LD A,#FD:IN A,(#FE);A
        BIT 0,A:JR Z,ABORT
        LD A,#FB:IN A,(#FE);R
        BIT 3,A:JR NZ,DSKERR1
        LD A,#FF:JR DOS2

ABORT   LD HL,BRKPRM
        CALL PUTMSG
ABRT1   XOR A
        IN A,(#FE)
        CPL:AND 31
        JR NZ,ABRT1
        CALL WRN1
ABRT2   LD A,1:SCF:RET

NONTRD  LD DE,NOTRDM:JR NODRV1

NODSK   LD DE,NODSKM:JR NODRV1

NODRV   LD DE,NODRVM
NODRV1  CALL RESCAT
        EX DE,HL
        CALL WRN
        XOR A:SCF:RET

WRN     CALL PUTMSG
WRN1    LD IX,VAR
        CALL WTKPR
        JP CLRMSG

DOS4    OR A :JP NZ,LDSV1
        DEC C:JR Z,SELDRV
        JP M,RDCAT
        INC C:JP LDSV

;CHECK CORRECT DRIVE
;OUT B=DRIVE Z=OK
CDISK   LD A,(DRIVE):LD B,A
        LD A,(DISK)
        AND 3:CP B
        RET

;A-DRIVE NC     O'K
;        C  A=0 BREAK
;        C  A=1 NO DRIVE
;        C  A=2 NO DISC
;        C  A=3 NON-TRDOS OR CAT_ERROR
;        C  A=4 DISC ERROR

SELDRV  DI
        LD A,B:AND #03:OR #3C
        LD (DISK),A
RDCAT   CALL CDISK
        JR NZ,SELDRV
        CALL INTER
        CALL REST
        LD A,1:SCF:RET Z
        LD BC,#0905
        LD DE,#0000
        LD HL,BUF1024
        CALL LDSV:RET C
        LD DE,CATBF+#08FF
        LD HL,BUF1024+#08FF
        LD BC,#0900
        LDDR
        XOR A:LD (CATBF+#0800),A
        LD A,(CATBF+#08E3)
        CP #16
        JR NZ,SELDRV1
        LD A,(CATBF+#08E7)
        CP #10
SELDRV1 JR NZ,SDRV5
        LD IX,CATBF
        LD DE,#0100
        LD H,E:LD L,E
        LD BC,#0010
SDRV2   LD A,(IX)
        OR A :JR Z,SDRV4
        INC H
        DEC A:JR NZ,SDRV3
        INC L
SDRV3   LD A,(IX+14):CP E:JR NZ,SDRV5
        LD A,(IX+15):CP D:JR NZ,SDRV5
        LD A,(IX+13)
        ADD A,E:LD E,A
.4      RRA
        AND #1F
        ADD A,D:LD D,A
        LD A,E:AND #0F:LD E,A
        ADD IX,BC
        JR SDRV2

SDRV4   LD A,(CATBF+#08E4):LD B,A
        LD A,(CATBF+#08F4):LD C,A
        XOR A:SBC HL,BC
        JR NZ,SDRV5
        LD HL,(CATBF+#08E1)
        SBC HL,DE
        JR NZ,SDRV5
.4      RR D:RRA
        OR E:LD E,A
        LD HL,2544:SBC HL,DE
        JR C,SDRV5
        EX DE,HL;  2544
        LD HL,(CATBF+#08E5)
        SBC HL,DE
        RET NC
SDRV5   LD A,3:SCF:RET

;DE-POS     NC     O'K
;HL-ADDR    C  A=0 BREAK
;B-NUM      C  A=1 NO DRIVE
;C=5 LOAD   C  A=2 NO DISC
;C=6 SAVE   C  A=3 NON-TRDOS
;LDSV1-CONT C  A=4 DISC ERROR

LDSV    LD (SECTR),DE
        LD (LSADR),HL
        LD (LSMODE),BC
LDSV1   DI
LDSV2   XOR A
LDSV3   EXA:CALL INTER:EXA
        LD (PROOF),A
        CP 1:JR Z,LDSV3A
        OUT (#FE),A
LDSV3A  OR A:JR Z,LDSV4
        AND 3:JR NZ,LDSV5
        CALL REST
        SCF:LD A,1:RET Z
LDSV4   LD A,(TRACK)
        CALL POS
LDSV5   CALL BREAK:RET C
        LD A,(SECTR)
        LD HL,(LSADR)
        LD D,0
        CALL LDSV9
        JR NC,LDSV7
        EXA:CALL INTER:EXA
        CP 3:SCF:RET Z
        CP 1
        JR NZ,LDSV6
        CALL INDEX
        LD A,2:SCF:RET Z
        LD A,4
LDSV6   LD B,A
        LD A,(PROOF):INC A
        CP #10:JR NZ,LDSV3
        LD A,B:SCF
        RET

LDSV7   LD HL,(LSADR):INC H
        LD DE,(SECTR):INC E
        BIT 4,E:JR Z,LDSV8
        RES 4,E:INC D
LDSV8   LD BC,(LSMODE)
        DJNZ LDSV
        LD (SECTR),DE
        OR A
        RET

LDSV9   PUSH HL
        INC A
        LD C,#5F:CALL OUTPAR
        LD A,(LSMODE)
        CP 6
        LD A,#80:LD IX,#3FD7
        JR NZ,LDSV10
        LD A,#A0:LD LX,#BC
LDSV10  LD C,#1F:CALL OUTPAR
        LD BC,#017F
        POP HL:PUSH HL
        CALL JPTR1
        POP DE
        SCF:LD A,1:RET Z
        INC D
        OR A:SBC HL,DE
        SCF:LD A,3:RET NZ
TEST    LD A,(#5CD6):PUSH AF
        CALL TEST1:DI
        POP AF:LD (#5CD6),A
        OR A:DEC B:RET Z
        LD A,4:SCF:RET

TEST1   LD HL,#20AA:PUSH HL
        LD A,#01:PUSH AF
        LD L,#99:JR JPTR

POS     SRL A
        LD C,#7F:CALL OUTPAR
        LD A,(DISK)
        JR NC,$+4
        RES 4,A
        LD C,#FF:CALL OUTPAR
        LD A,#18
        JR REST1

JPTR1   DB #DD
JPTR    PUSH HL
JPTR2   JP #3D2F

REST    LD A,(DISK)
        LD C,#FF:CALL OUTPAR
        LD A,8
REST1   LD DE,25000
CMND    CALL OUTCMND
READY   LD HL,#3FD7
        LD BC,#017F
        JR JPTR

INDEX   CALL INTER
        LD DE,20000
        LD A,#D4
        JR CMND

INTER   LD A,#D0
OUTCMND LD C,#1F
OUTPAR  LD HL,#2A53:JR JPTR

BREAK   LD A,#FE:IN A,(#FE)
        RRA:LD A,#FF:RRA
        IN A,(#FE):RRA:CCF
        LD A,0
        RET

BRKPRM  DB "BREAK",0
NODSKM  DB "No disk",0
NODRVM  DB "No drive",0
NOTRDM  DB "Corrupted disk",0
DSKERRM DB "Disk error (R/A)",0

;**************************************


BLKBEG  LD HL,(AELINE)
        DEC HL
        LD (BLKB),HL
        LD HL,MBSTAT
        SET 1,(HL)
        BIT 2,(HL)
        JR EMK

BLKEND  LD HL,(AELINE)
        DEC HL
        LD (BLKE),HL
        LD HL,MBSTAT
        SET 2,(HL)
        BIT 1,(HL)
EMK     RET Z

ENMARK  BIT 5,(IX)
        LD HL,BUFED
        SET 7,(HL):LD A,#F6
        JR Z,EMK0
        RES 7,(HL):LD A,#B6
EMK0    LD (EMKM+1),A;SELF-MOD
        LD HL,(BLKE),BC,(BLKB)
        OR A:SBC HL,BC:RET C
        LD A,(MBSTAT)
        OR #20
        LD (MBSTAT),A
        ADD HL,BC:PUSH BC
        LD C,L:LD B,H
        CALL MBSCHD
        SBC HL,BC
        JR Z,EMK2
EMK1    ADD HL,BC
        RES 6,E
        SBC HL,DE
        LD E,(HL):INC E
        SBC HL,BC
        JR Z,EMK2
        JP NC,EMK1
EMK2    ADD HL,BC
        POP BC
EMK3    RES 6,E
EMKM    SET 6,(HL)
        SBC HL,DE
        LD E,(HL):INC E
        SBC HL,BC
        JR C,MBEX
        ADD HL,BC
        JR EMK3

TGLBM   CALL RESBLK
        LD HL,KEYSTAT
        LD A,(HL):XOR #20
        LD (HL),A
        JR MBEX

UNMARK  CALL UNMK1:JR MBEX
UNMK1   RES 6,E:RES 6,(HL)
        SBC HL,DE:LD E,(HL)
        INC E:JP NZ,UNMK1
        CALL RESBLK
        EX DE,HL:RES 5,(HL)
        LD HL,BUFED:RES 7,(HL)
        CALL WRLIN
        OR A:RET Z
INP2Y   POP HL
INP2X   POP HL:JP INP2

UNDOLN  LD BC,(ABLINE):CALL DLNA
        CALL MVBUF
MBEX    CALL INIT3
        JP RETHINK
MBEX1   LD HL,MBSTAT
        SET 4,(HL)
        JR MBEX

COPYBL  CALL CPB0
        JR C,INP2X
        JR MBEX1

DELEBL  CALL DLB1
        JR C,INP2X
DELEX   CALL DLB6
        JR MBEX1

MOVEBL  CALL CPB0
        JR C,INP2X
        LD HL,(ABLINE)
        PUSH HL
        CALL MBSCHD
        CALL DLB1
        POP HL
        JR DELEX

CPB0    LD IY,0
CPB1    BIT 6,E:RES 6,E
        JR Z,$+4:ADD IY,DE
        OR A:SBC HL,DE
        LD E,(HL):INC E
        JP NZ,CPB1
        LD BC,IY;BLK LEN
        LD A,B:OR C:SCF:RET Z
        LD HL,TOP-2
        LD DE,(ETEXT)
        OR A:SBC HL,DE
        LD A,6:RET C
        SBC HL,BC
        RET C
        LD HL,(ETEXT)
        LD DE,(ABLINE)
        SBC HL,DE:PUSH HL
        ADD HL,DE:LD DE,HL
        ADD HL,BC:LD (ETEXT),HL
        EX DE,HL:DEC HL,DE
        POP BC
        CALL FLDDR
        PUSH DE
        EXX
        CALL MBSCHD
        POP BC
        SBC HL,BC:JR Z,CPB6
        ADD HL,BC
CPB3    BIT 6,E:RES 6,E
        JR Z,CPB4
        RES 6,(HL)
        PUSH DE,HL
        EXX
        POP HL,BC
        LDDR
        EXX
        SET 6,(HL)
CPB4    OR A:SBC HL,DE
        SBC HL,BC:JR Z,CPB6
        ADD HL,BC
CPB5    LD E,(HL):INC E
        JP NZ,CPB3
        CALL NEWLINE,RESBLK
        XOR A:RET
CPB6    LD HL,(ABLINE):DEC HL
        JR CPB5

;C=NO BLOCK NC=OK
DLB0    LD LY,0
DLB1    RES 6,E:BIT 6,(HL)
        JR NZ,DLB2
        SBC HL,DE:LD E,(HL)
        INC E:JP NZ,DLB1
        LD A,LY:SUB 1
        LD A,0:RET C
        JR DLB5
DLB2    PUSH HL
DLB3    RES 6,E:BIT 6,(HL)
        JR Z,DLB4
        SBC HL,DE:LD E,(HL)
        INC E:JP NZ,DLB3
DLB4    POP BC
        PUSH HL,DE
        INC HL,BC
        EX DE,HL
        LD HL,(ETEXT)
        OR A:SBC HL,BC
        LD A,B,B,H,H,A
        LD A,C,C,L,L,A
        LD (ABLINE),DE
        CALL FLDIR
        LD (ETEXT),DE
        POP DE,HL
        LD LY,1
        OR A:SBC HL,DE
        LD E,(HL)
        INC E:JP NZ,DLB1
DLB5    LD HL,(ABLINE)
        LD A,(HL):INC A
        RET NZ;NC
        LD (HL),0:INC HL
        LD (HL),#FF:INC HL
        LD (ETEXT),HL
        DEC HL:DEC HL
        RET ;NC
;IN:HL=LINE
DLB6    CALL RESBLK
        LD A,(PY):LD C,A
        JP SCREPOS

GO_BOTT LD IY,#FFFF
GBT1    RES 6,E:INC IY
        SBC HL,DE:LD E,(HL)
        INC E:JP NZ,GBT1
        CALL MBSCHD:RES 6,E
        SBC HL,DE:INC HL
GBT3    LD (ABLINE),HL
        LD C,HGT:CALL SCRP2
GBT4    JP RETHINK

GO_TOP  LD BC,BEGBTX+1,(ABLINE),BC
        CALL NEWLINE
        LD A,1:LD (PY),A
        LD HL,0,(NLINE),HL
        JR GBT4

GO_PREV LD HL,(ABLINE):DEC HL
        LD E,(HL):INC E:RET Z
GPV1    BIT 6,E:RES 6,E
        JR NZ,GPV2
        SBC HL,DE:LD E,(HL)
        INC E:JP NZ,GPV1
        RET
GPV2    INC HL:JR GNX2A

GO_NEXT LD BC,(AELINE):DEC BC
        LD (USP),BC
GNX     RES 6,E
        OR A:SBC HL,BC
        JR C,GNX2,Z,GNX2
        ADD HL,BC
        BIT 6,(HL):JR NZ,GNX3
GNX1    OR A:SBC HL,DE
        LD E,(HL)
        INC E:JP NZ,GNX
GNX2    LD HL,(USP):LD E,(HL)
        RES 6,E
GNX2A   OR A:SBC HL,DE
        LD A,(PY):LD C,A
        JP SCREPOS
GNX3    LD (USP),HL:JR GNX1

REPLACE LD HL,SRCHT,DE,SRCHBF
        CALL REQ6
        LD HL,REPLT,DE,REPLBF
        CALL REQ6,SRH0
        RET C
        LD HL,REPLBF+23,B,24
        CALL FNLAST
        LD (RPLY2+1),A
RPL2    LD HL,SRCHT1
        CALL PUTMSG
        CALL SRH2
        JP C,NEWLINE
RPL4    LD C,11:CALL SCRP0
        CALL PRSTAT
        CALL RETHINK,CURON
        LD HL,REPLR
        CALL PUTMSG
RPL5    CALL WTKPR
        LD A,(RAWKEY)
        CP 2:JR Z,RPLY
        CP 8:JR Z,RPL2
        CP 38:JR Z,RPLA
        CP 37:JR Z,RPL6
        JR RPL5
RPL6    JP NEWLINE

RPLY    CALL RPLY0
        CALL REFRESH,PRSTAT
        JR RPL2

RPLA    CALL RPLY0
        LD HL,SRCHT1
        CALL PUTMSG
RPLA1   CALL SRH2
        JR C,RPLA2
        LD (ABLINE),HL
        CALL NEWLINE
        CALL RPLY0
        JR RPLA1
RPLA2   LD HL,(ABLINE)
        LD C,11:CALL SCRP0
        CALL RETHINK
        JP CURON

RPLY0   LD HL,BUFED+1
        LD C,(IX+1):LD B,0
        ADD HL,BC:LD DE,HL
        LD A,(SRH2+1):INC A
        LD C,A,HY,A
        SBC HL,BC:EX DE,HL
        LD A,40:SUB (IX+1)
        LD C,A
        PUSH BC
        LDIR
        PUSH DE
        LD B,HY,A,#20
        LD (DE),A:INC DE
        DJNZ $-2
        POP DE
RPLY2   LD HL,0
        LD A,L:LD LY,A
        ADD HL,DE:EX DE,HL
        DEC DE,HL
        POP BC
        LDDR
        LD C,A
        EX DE,HL:INC DE
        LD HL,REPLBF
        INC C:DEC C
        JR Z,$+4:LDIR
        LD HL,PX
        LD A,(HL)
        ADD A,LY:SUB HY
        CP 40:JR C,$+4:LD A,39
        LD (HL),A
        LD HL,MBSTAT:SET 4,(HL)
        RES 1,(IX+4)
        CALL WRLIN
        OR A
        RET Z
        PUSH AF
        CALL CLRMSG
        CALL PRLN
        POP AF
        JP INP2Y

SEARCH  LD HL,SRCHT,DE,SRCHBF
        CALL REQ6,SRH0
        RET C

NEXT    LD HL,SRCHT1
        CALL PUTMSG
        CALL SRH2
        JR NC,NXT1
        LD HL,SRCHNF
        CALL PUTMSG
        CALL WTKPR
        JP NEWLINE
NXT1    LD C,11:JP SCREPOS

SRH0    LD HL,SRCHBF+23,B,24
        CALL FNLAST
        OR A:SCF:RET Z
        DEC A:LD (SRH2+1),A
        XOR A
        RET

FNLAST  LD A,#20
FNLT1   CP (HL):JR NZ,FNLT2
        DEC HL:DJNZ FNLT1
FNLT2   LD A,B
        RET

SRH2    LD A,1:LD HY,A
        LD A,39:SUB HY:LD LY,A
        LD BC,(ABLINE)
        PUSH IY
        CALL DLNA
        POP IY
        PUSH BC
        LD A,39,HL,PX:SUB (HL)
        SUB HY:JR C,SRH6
        LD C,A
        LD E,(HL):LD D,0
        LD HL,BUFDPC+1
        ADD HL,DE
        JR SRH4
SRH3    PUSH BC
        LD HL,BUFDPC+1
        LD C,LY
SRH4    LD DE,SRCHBF,B,0
        LD A,(DE):INC DE
        CPIR
        JP PE,$+5:JR NZ,SRH6
        LD B,HY;LEN
        DEC B:INC B:JR Z,SRH7
        LD A,C:CP B:JR C,SRH6
SRH5    LD A,(DE):CP (HL)
        JR NZ,SRH4
        INC DE:INC HL
        DJNZ SRH5
        JR SRH7
SRH6    POP BC
        LD A,(BC)
        INC A:SCF
        RET Z;NOT FOUND
        PUSH IY
        CALL DLNA
        POP IY
        JR SRH3

SRH7    LD DE,BUFDPC+1;FOUND
        OR A:SBC HL,DE
        LD A,L:LD (PX),A
        POP HL:DEC HL
        LD E,(HL):RES 6,E
        XOR A:LD D,A
        SBC HL,DE
        RET

JUMPLN  LD BC,0
JLN1    RES 6,E:INC BC
        SBC HL,DE:LD E,(HL)
        INC E:JP NZ,JLN1
        LD (JLN5+1),BC;TOTAL LINES
        LD HL,JPLNT
        CALL PUTMSG
        LD HL,JPLNBF
        PUSH HL
        LD B,4:CALL FILLB
        POP HL:PUSH HL
        LD C,1
        CALL LOWEDIT
        POP DE
        RET Z
        LD A,(DE):CP #20:RET Z
        LD HL,0
JLN2    LD A,(DE)
        SUB #30:JR C,JLN3
        CP #0A:JR NC,JLN3
        INC DE
        ADD HL,HL:LD BC,HL
        ADD HL,HL,HL,HL,HL,BC
        LD C,A,B,0:ADD HL,BC
        JR JLN2

JLN3    EX DE,HL
JLN5    LD HL,0
        OR A:SBC HL,DE
        JR NC,JLN4
        LD HL,1
JLN4    LD C,L:LD B,H:INC BC
        CALL MBSCHD
        LD A,C:OR A:JR Z,JLN8
        INC B
JLN6    RES 6,E
        DEC C:JR NZ,JLN7
        DEC B:JR Z,JLN8
JLN7    SBC HL,DE:LD E,(HL)
        INC E:JP NZ,JLN6
JLN8    INC HL:JP NXT1

ZAPTEXT LD HL,ZAPTM
        CALL PUTMSG
        CALL WTKPR
        CALL CLRMSG
        LD A,(RAWKEY)
        CP 2:RET NZ
ERTEXT  LD A,1:LD (INIT1C+1),A
ZAPT0   CALL INIT1B
ZAPT1   CALL PRFREE,PRTEXT,PRFILE
        LD HL,BEGBTX+1
        LD C,0
        JP SCREPOS

INIT    DI
        CALL SBTXT
        LD (IX+0),#82
        RES 0,(IX+4)
        XOR A:LD H,A:LD L,A
        LD (CACHEST),HL
        INC A:LD (REPPER),A
        LD A,KEYDEL:LD (REPDEL),A
        LD H,#30
        LD (PXOLD),HL,(ACUR),HL
        LD HL,(ETEXT):DEC HL
        LD E,(HL):INC E
        JR NZ,INIT1B
        DEC HL
        LD BC,BEGBTX+1
        XOR A:LD D,A
INIT1   LD E,(HL):RES 6,E
        SCF:SBC HL,DE
        SBC HL,BC:ADD HL,BC
        JP NC,INIT1
        DEC BC
        OR A:SBC HL,BC
        JR NZ,INIT1B
        ADD HL,BC;VALID
        LD A,(HL)
        INC A:JR Z,INIT2
INIT1B  LD HL,BEGBTX;NOT VALID
        LD (HL),#FF:INC HL
        LD (ABLINE),HL
        LD (HL),0:INC HL
        LD (HL),#FF:INC HL
        LD (ETEXT),HL
        CALL CLTXN
INIT1C  LD A,1:OR A
        JR NZ,INIT2
        LD HL,TXNVALM
        CALL WRN
        LD HL,0
        LD (NLINE),HL
        INC H
        LD (PX),HL
INIT2   XOR A:LD (INIT1C+1),A
        LD (MBSTAT),A
        LD HL,TXNAME
        LD DE,WNAME
        LD BC,8
        LDIR
        CALL INIT3
INIT2A  LD BC,(ABLINE)
        CALL DLNA
        LD (AELINE),BC
        RET

INIT3   CALL MBSCHD
INI3A   BIT 6,E:JR NZ,INI3B
        RES 6,E:SBC HL,DE
        LD E,(HL):INC E
        JP NZ,INI3A
INI3B   LD HL,MBSTAT
        RES 5,(HL)
        RET Z
        SET 5,(HL)
        RET

IMPORT  LD HL,INPM
        CALL DSINP
        CALL CLTXN
IMP1    LD DE,IMPNAME
        CALL FILEFL
        JP C,LOAD0
        LD C,(HL):INC HL
        LD B,(HL):INC HL
        INC HL
        LD E,(HL):INC HL
        LD D,(HL)
        LD (SECTR),DE
        LD HL,BEGBTX+1
        LD (ETEXT),HL
        LD H,BUF1024/256+7
IMP2    LD DE,BUFED
        XOR A:LD (DE),A:INC DE
IMP3    CALL IMP14:JR Z,IMP6
        LD A,(HL):INC HL:DEC BC
        CP #20:JR NC,IMP4
        CP #0D:JR Z,IMP7
        CP #0A:JR Z,IMP8
        LD A,#20
IMP4    LD (DE),A:INC E
        LD A,E:CP BUFED]+42
        JR NZ,IMP3
        PUSH HL
        DEC E:LD A,(DE):LD H,A
        DEC E:LD A,(DE):LD L,A
        EX (SP),HL
        XOR A:LD (DE),A:INC E
        CALL IMP11
        POP DE
        JR C,IMP9D
        LD A,D:LD (BUFED+2),A
        LD A,E:LD DE,BUFED+1
        LD (DE),A:INC E,E
        JR IMP3

IMP6    LD A,E:CP BUFED]+1
        JR NZ,IMP8
        LD HL,(ETEXT):LD BC,BEGBTX+1
        SBC HL,BC; NC!!!
        LD BC,HL
        JP LOAD3

IMP7    CALL IMP14:JR Z,IMP8
        LD A,(HL)
        CP #0A:JR NZ,IMP8
        INC HL:DEC BC
IMP8    XOR A:LD (DE),A:INC E
        LD A,(BUFED):RLA
        JR C,IMP9A
        PUSH HL,BC,DE
        CALL PLN
        JR C,IMP9
        LD BC,BUFPC
        PUSH AF
        CALL DLN
        POP BC
        JR NZ,IMP10
IMP9    POP DE,BC,HL
IMP9A   LD A,E:CP BUFED]+42
        JR NZ,IMP9B
        DEC E,E:LD A,(DE):PUSH AF
        XOR A:LD (DE),A:INC E
        CALL IMP11
        POP DE:JR C,IMP9D
        LD A,D:LD DE,BUFED
        LD (DE),A:INC E
        XOR A:LD (DE),A:INC E
IMP9B   CALL IMP11
IMP9C   JP NC,IMP2
IMP9D   LD HL,FTOOBM
        CALL WRN
        PUSH AF
IMP9E   POP AF
        JP ERTEXT

IMP10   LD A,B
        CALL IMP12
        POP DE,BC,HL
        JR IMP9C

IMP11   PUSH HL:PUSH BC
        LD HL,DE:DEC L
        LD B,0:LD C,L
        LDDR
        SET 7,(HL)
        LD A,";":LD (DE),A
        CALL PLN
        CALL IMP12
        POP BC:POP HL
        RET

IMP12   LD HL,BUFPC
        LD C,A:XOR A:LD B,A
        LD DE,(ETEXT)
        LDIR
        LD (ETEXT),DE
        LD HL,TOP-1
        SBC HL,DE; NC!!!
        RET

IMP14   LD A,B:OR C:RET Z
        LD A,H:CP BUF1024/256+7
        RET NZ
        LD A,C:OR A
        LD A,B
        JR Z,IMP15
        INC A
IMP15   CP 8:JR C,IMP16
        LD A,7
IMP16   SCF:CALL EXP14
        JR C,IMP9E
        LD HL,BUF1024
        OR H:RET

EXPORT  LD HL,EXPM
        CALL DSINP
        CALL EXP2
        PUSH AF:CALL RETHINK:POP AF
        RET NC
        CP 3:JP Z,LOAD0A
        CP 4:JP Z,SAVE0
        RET

EXP2    LD DE,EXPNAME
        LD A,(SAVEMD):AND #03
        CALL FILEKL
        JR NC,EXP3
        CP 2:SCF:RET NZ
EXP3    LD A,(CATBF+#08E4)
        CP #80:JP Z,FLSV2A
        LD HL,(CATBF+#08E1)
        LD (SECTR),HL
        LD HL,(CATBF+#08E5)
        LD E,#FF
        LD A,H:OR A
        JR NZ,EXP3A
        LD E,L
EXP3A   LD D,0
        LD BC,BEGBTX+1
        LD HL,BUF1024
EXP4    LD A,(BC):INC A:JR Z,EXP12
        PUSH DE,HL
        CALL DLNA
        POP DE
        PUSH BC
        LD HL,BUFDPC+1
        LD B,41
        LD A,#20
EXP5    LD C,0
EXP6    CP (HL):JR NZ,EXP8
        INC C,L
        DJNZ EXP6
        JR EXP9

EXP7    LD (DE),A:INC DE
EXP8    DEC C:JP P,EXP7
        LDI:DJNZ EXP5
EXP9    EX DE,HL
        LD (HL),#0D:INC HL
        POP BC:POP DE
        LD A,H:CP BUF1024/256+6
        JR NZ,EXP4
        LD A,E:SUB 6
        JR C,EXP11
        LD E,A
        LD A,D:ADD A,6:LD D,A
        JR C,EXP11A
        LD A,6
        CALL EXP14;NC
        RET C
        LD A,L
        EXX
        LD C,A:LD B,0
        LD HL,BUF1024+#0600
        LD DE,BUF1024
        OR A:JR Z,EXP10
        LDIR
EXP10   PUSH DE:EXX:POP HL
        JR EXP4

EXP11   LD A,4:SCF:RET
EXP11A  LD A,3:SCF:RET

EXP12   LD A,H:SUB BUF1024/256
        LD H,A:LD C,A
        LD A,L:OR A
        JR Z,EXP13
        INC C
EXP13   LD A,E:SUB C
        JR C,EXP11
        LD A,D:ADD A,C:JR C,EXP11A
        LD E,0
        ADD HL,DE;LEN
        LD A,C:OR A
        CALL NZ,EXP14;NC
        LD B,H:LD C,L
        LD DE,EXPNAME
        JP FLSV4

EXP14   PUSH BC,DE,HL
        LD HL,BUF1024
        LD DE,(SECTR)
        LD B,A:LD C,6
        JR NC,EXP15
        DEC C
EXP15   CALL DOS
        POP HL,DE,BC
        RET

;***************************************

SAVE    LD HL,SAVEM
        CALL DSINP
        CALL WORK2TX
        LD DE,BEGBTX+1
        LD HL,(ETEXT):DEC HL
        OR A:SBC HL,DE
        LD BC,HL:EX DE,HL
        LD DE,WNAME
SAVE1   CALL FILESV
        PUSH AF
        LD HL,MBSTAT
        RES 4,(HL)
        CALL MBEX
        POP AF
        RET NC:CP 3:RET NZ
SAVE0   LD HL,NOSPCM
SAVE0A  JP WRN

KILL    LD HL,KNAME
        LD B,8:CALL FILLB
        LD HL,KILLM
        CALL DSINP
        LD DE,KNAME
        LD A,(KILLMD)
        SET 7,A
        CALL FILEKL
        PUSH AF
        CALL RETHINK
        POP AF
        RET NC:CP 2:RET NZ
        LD HL,NOFILEM
        JR SAVE0A

LOAD    LD HL,LOADM
        CALL DSINP
        CALL SBTXT
        LD DE,WNAME
        LD HL,BEGBTX+1
        LD BC,TOP-BEGBTX
        CALL FILELD
LOAD0   JR NC,LOAD3
LOAD0A  CP 2:JP C,ZAPT0
        LD HL,NOFILEM
        JR Z,LOAD2
        LD HL,FTOOBM
LOAD2   CALL WRN
LOAD2A  JP RETHINK

LOAD3   PUSH BC
        CALL WORK2TX
        POP BC
        LD HL,BEGBTX
        LD (HL),#FF:INC HL
        LD (ABLINE),HL
        ADD HL,BC
LOAD4   LD (HL),#FF:INC HL
        LD (ETEXT),HL
        CALL INIT
        JP ZAPT1

MERGE   LD HL,MERGEM
        CALL DSINP
        CALL MBSCHD
        CALL UNMK1
        CALL GETOP
        RET C,Z
        LD DE,MNAME
        LD BC,HL
        LD HL,(ETEXT):DEC HL
        PUSH HL
        CALL FILELD
        POP HL
        JP C,LOAD0
MERG2   ADD HL,BC
        LD (HL),#FF
        PUSH HL
        DEC HL
        LD BC,(ETEXT)
        DEC BC:DEC BC
        LD D,0
MERG3   LD E,(HL)
        INC E:JR Z,MERG5
        SET 6,(HL):RES 6,E
        SBC HL,DE
        SBC HL,BC
        JR Z,MERG4
        JR C,MERG5
        ADD HL,BC
        JR MERG3

MERG4   POP HL:INC HL;VALID
        LD (ETEXT),HL
        CALL PRSTAT
MERG4A  JR LOAD2A

MERG5   POP HL
MERG6   LD HL,(ETEXT)
        DEC HL:LD (HL),#FF
        LD HL,TXNVALM
        CALL WRN
        JR MERG4A

SAVEBLK LD HL,SVBLKM
        CALL DSINP
        CALL MBSCHD
        LD B,3:LD A,E
        AND #40:LD C,A
        JR Z,SVBL1
        PUSH HL:DEC B
SVBL1   RES 6,E:INC IY
        OR A:SBC HL,DE
        LD E,(HL)
        INC E:JR Z,SVBL2
        LD A,E:AND #40
        CP C:JR Z,SVBL1
        DEC B:LD C,A
        PUSH HL
        JR NZ,SVBL1
        JR SVBL3
SVBL2   LD A,B:CP 3:RET Z
        DEC B:JR Z,$+3
        PUSH HL
        POP DE
        POP HL
        PUSH DE
        OR A:SBC HL,DE
        LD C,L:LD B,H
        POP HL:INC HL
        LD DE,MNAME
        JP SAVE1

SVBL3   POP HL,HL,HL
        LD HL,SVBLM
        JP WRN

CAT     LD C,0
        CALL DOS
        JP C,RETHINK
        LD HL,(CATBF+#08E5)
        CALL CORRDW
        EX DE,HL
        LD HL,CATM
        PUSH HL
        LD (HL),D:INC HL
        LD (HL),E:INC HL
        LD (HL),B:INC HL
        LD (HL),C
        POP HL
        CALL PUTMSG
        LD HL,CATBF
CAT1    PUSH HL
        LD DE,#0100
        LD BC,(HGT')+32
        LD A,CATCOL
        CALL WIND
        LD HL,CATT
        LD DE,#0101
        LD C,9:LD A,2
        CALL PRSTRI
        LD LY,HGT-2
        POP HL
CAT2    LD A,(HL)
        OR A:JP Z,CAT6
        CP 1:JR NZ,CAT2A
        LD DE,16:ADD HL,DE
        JR CAT2
CAT2A   PUSH IY,HL
        LD HL,BUFF32
        PUSH HL
        LD B,33:CALL FILLB
        LD (HL),0
        POP DE,HL
        LD C,8
        LDIR:INC DE
        LDI:INC DE
        LD BC,HL
        PUSH DE
        EX DE,HL
        LD A,6
        CALL DL49;ADR
        POP HL
        LD DE,6:ADD HL,DE
        PUSH HL,DE
        LD A,E
        CALL DL49;LEN
        POP DE,HL
        ADD HL,DE
        PUSH HL
        LD A,2
        CALL DL49;SECLEN
        POP HL
        LD DE,4:ADD HL,DE
        INC BC
        PUSH HL,DE
        LD A,2
        CALL DL49;TRK
        POP DE,HL
        ADD HL,DE
        DEC BC,BC
        LD A,2
        CALL DL49;SEC
        INC BC:PUSH BC
        LD A,HGT+1
        SUB LY
        LD D,A:LD E,1
        LD HL,BUFF32
        LD C,9:LD A,E
        CALL PRSTRI
        POP HL,IY
        DEC LY:JP NZ,CAT2
CAT6    CALL WTKPR
        LD A,(HL)
        OR A:JP NZ,CAT1
        CALL PSCR
        CALL RESCAT
        JP CLWIND

SRCHT   DB "Search string",0
SRCHT1  DB "Searching",0
SRCHNF  DB "Not found",0
REPLT   DB "Replace to",0
REPLR   DB "Replace? Y/N/A/Q",0
JPLNT   DB "Jump to line",0
INSPT   DB "Enter expression",0
ZAPTM   DB "Zap source? Y/N",0

CATT    DB "Name       Adr   "
        DB "Len   Sec Tr/Sec",0
CATM    DB ".... Free",0
SRCHBF  DS 24,#20
REPLBF  DS 24,#20
CALCA   DB 0,#20
CALCBF  DS 28,#20
CLRMES  DB 0
JPLNBF  DS 4,#20
        DB 0

LOADM   DB "Load source",0
        DB WNAME-$
SAVEM   DB "Save source",0
        DB WNAME-$
KILLM   DB "Kill file",0
        DB KNAME-$
INPM    DB "Import text",0
        DB IMPNAME-$
EXPM    DB "Export text",0
        DB EXPNAME-$
MERGEM  DB "Merge source",0
        DB MNAME-$
SVBLKM  DB "Save block",0
        DB MNAME-$
SVOBJM  DB "Save OBJ",0
        DB ONAME-$
MNAME   DB "        C"
ONAME   DB "        C"
WNAME   DB "        C"
KNAME   DB "        C"
IMPNAME DB "        C"
EXPNAME DB "        C"
NOSPCM  DB "No disk space",0
FTOOBM  DB "File too big",0
TXNVALM DB "Text not valid",0
SVBLM   DB "More then 1 block",0

EXTJTB  DB 18
_DW 0,BLKBEG,21,BLKEND
_DW 8+256,UNMARK,17,TGLBM
_DW 10+256,UNDOLN,9,JUMPLN
_DW 15,COPYBL,22,DELEBL
_DW 16,MOVEBL
_DW 11,GO_TOP,3,GO_BOTT
_DW 4,GO_PREV,19,GO_NEXT
_DW 30,SEARCH,23,NEXT,13,REPLACE
_DW 38,ASSEMB,18,INSPECT

ALTJTB  DB 14
_DW 38,ASSEMB,37,QUIT,22,DEBUG
_DW 25,LOAD,30,SAVE,17,KILL
_DW 31,ZAPTEXT,15,CAT,16,MERGE
_DW 5,IMPORT,23,EXPORT
_DW 0,SAVEBLK,26,SAVEOBJ
_DW 13,RUN

;18,INFO,10,CALLSUB
;34,PRINT,21,SETUP

